<script setup>

import { onMounted, reactive } from 'vue';
import { useRouter, useRoute } from 'vue-router';
import { recordSellTransactionUrl, recordBuyTransactionUrl, querySupportedPairsUrl } from '../lib/CoinfolioAPI';

let router = useRouter();
let route = useRoute();

let state = reactive({
    transactionDirection: "",
    pair: "",
    amount: "",
    fee: "",
    pricePerUnit: "",
    momentOfTransaction: new Date().toISOString(),
    exchange: "",
    notes: "",
    supportedPairs: {},
    selectedBaseCurrency: "",
    selectedQuoteCurrency: "",
});

onMounted(async () => {
    var res = await fetch(querySupportedPairsUrl);
    var pairs = await res.json();

    state.supportedPairs = pairs;
});

async function recordTransaction() {
    var payload = {
        coinfolioId: route.params.coinfolioId,
        ownerToken: route.params.ownerToken,
        pair: state.pair,
        amount: state.amount,
        unitPrice: state.pricePerUnit,
        fee: state.fee,
        momentOfTransaction: state.momentOfTransaction,
        exchange: state.exchange,
        notes: state.notes,
    };

    let url;
    if(state.transactionDirection === "SELL") {
        url = recordSellTransactionUrl;
    }
    else if(state.transactionDirection === "BUY") {
        url = recordBuyTransactionUrl;
    }
    else {
        alert("invalid transaction direction!");
        return;
    }

    let res = await fetch(url, {
        method: "POST",
        headers: {
            "Content-Type": "application/json",
        },
        body: JSON.stringify(payload),
    });

    if(res.status != 200) {
        alert("record transaction failed!");
        return;
    }

    router.push("/");
}

function pairChanged($event) {
    const selectedPair = $event.target.value + "";

    if(selectedPair === "") {
        state.selectedBaseCurrency = "-";
        state.selectedQuoteCurrency = "-";
    }
    else {
        const [baseCurrency, quoteCurrency] = selectedPair.split("/", 2);
        state.selectedBaseCurrency = baseCurrency;
        state.selectedQuoteCurrency = quoteCurrency;
    }
}

</script>

<template>
    <h1>Record Transaction</h1>
    <form class="col-8">
        <div class="mb-3">
            <input type="radio" class="btn-check" name="options-outlined" id="success-outlined" autocomplete="off" value="BUY" v-model="state.transactionDirection">
            <label class="btn btn-outline-success" for="success-outlined">Buy</label>
            <input type="radio" class="btn-check" name="options-outlined" id="danger-outlined" autocomplete="off" value="SELL" v-model="state.transactionDirection">
            <label class="btn btn-outline-danger" for="danger-outlined">Sell</label>
        </div>
        <div class="mb-3">
            <label>Pair</label>
            <select class="form-select" v-model="state.pair" @change="pairChanged($event)">
                <option selected value="">Select Pair</option>
                <option v-for="pair in state.supportedPairs" :value="pair">{{ pair }}</option>
            </select>
        </div>
        <div class="mb-3">
            <label>Amount</label>
            <div class="input-group">
                <input class="form-control" v-model="state.amount" type="text" placeholder="Amount" /><br/>
                <span class="input-group-text" id="basic-addon2">{{ state.selectedBaseCurrency }}</span>
            </div>
        </div>
        <div class="mb-3">
            <label>Price per Unit</label>
            <div class="input-group">
                <input class="form-control" v-model="state.pricePerUnit" type="text" placeholder="PricePerUnit" /><br/>
                <span class="input-group-text" id="basic-addon2">{{ state.selectedQuoteCurrency }}</span>
            </div>
        </div>
        <div class="mb-3">
            <label>Fee</label>
            <div class="input-group">
                <input class="form-control" v-model="state.fee" type="text" placeholder="Fee" /><br/>
                <span class="input-group-text" id="basic-addon2">{{ state.selectedQuoteCurrency }}</span>
            </div>
        </div>
        <div class="mb-3">
            <label>Moment of transaction (ISO8601)</label>
            <input class="form-control" v-model="state.momentOfTransaction" type="text" placeholder="MomentOfTransaction" />
        </div>
        <div class="mb-3">
            <label>Exchange</label>
            <input class="form-control" v-model="state.exchange" type="text" placeholder="Exchange" />
        </div>
        <div class="mb-3">
            <label>Notes</label>
            <textarea class="form-control" v-model="state.notes" type="text" placeholder="Notes"></textarea>
        </div>
        <button class="mt-4" @click.prevent="recordTransaction()">Record Transaction</button>
    </form>
</template>